DevToolPal
EN

Email Address Syntax Checker

Check the syntax of one or many email addresses, find common domain typos and remove duplicates. Format check only, no mailbox lookup.

Runs locally, never uploaded

Options

Show

Email addresses (one per line)

0 chars · 0 B

Syntax check

Result appears here

What it does

This tool checks whether email addresses are written correctly. Paste one address or a whole list, and each one is marked valid or invalid with the reason, such as a missing @, two dots in a row, a domain without a dot or a character that is not allowed. It is useful for cleaning a mailing list before an import, checking form input rules, or finding the one broken row in a CSV export.

It checks the format only. It does not contact any mail server, so it cannot tell whether the mailbox exists or accepts mail.

How to use

  1. Paste addresses into the input box, one per line. Commas and semicolons also work as separators, so you can paste a To: line directly.
  2. Results appear as you type, with a summary of how many addresses are valid and invalid.
  3. Use Show to list all, only valid or only invalid addresses. Remove duplicates drops repeats; the domain is compared without regard to case.
  4. Press Copy valid to copy the clean list, one address per line.

Display names are handled too: Bob Smith <bob@example.com> is checked as bob@example.com with a note that the name was removed.

What is checked

  • Exactly one @ (outside quotes), with something on both sides.
  • The whole address is at most 254 characters and the part before @ at most 64.
  • The local part uses allowed characters, with no leading, trailing or doubled dots. Quoted local parts like "john doe"@example.org are allowed with a warning.
  • The domain has at least two labels, each 1–63 characters of letters, digits and hyphens, not starting or ending with a hyphen, and a real-looking top-level domain. IP literals such as admin@[192.168.0.1] are allowed with a warning.
  • Common misspellings of popular domains, such as gmial.com or qq.con, get a “did you mean” suggestion.

Example

alice@example.com        valid
lisi@gmial.com           valid, did you mean lisi@gmail.com?
two@@example.com         invalid: more than one @
user@localhost           invalid: domain needs a dot
用户@例子.中国            valid, internationalized address

FAQ

› Does this check whether the mailbox exists?

No. This is a syntax check only. It does not look up the domain's mail servers or contact them, so an address can pass here and still bounce. Confirming a mailbox needs a server, and the only reliable test is sending a confirmation email.

› Are the addresses uploaded?

No. Every check runs in your browser, so your mailing lists never leave your device.

› Which rules does it follow?

The address syntax in RFC 5321 and RFC 5322, plus internationalized addresses from RFC 6531. Obsolete forms such as comments inside addresses are rejected because almost no mail system accepts them.

› Why is a valid address marked with a warning?

Some addresses are legal but risky: a likely typo such as gmial.com, an IP address instead of a domain, a quoted local part, or non-ASCII characters that some servers refuse. The address still counts as valid.